goog.provide 'server.App'

class server.App

  ###*
    @param {Function} express
    @param {boolean} isDev
    @param {number} port
    @param {app.Routes} routes
    @param {app.DocumentCreator} documentCreator
    @constructor
  ###
  constructor: (express, isDev, port, routes, @documentCreator) ->
    app = express()

    app.get '/document.html', @onSaveDocument
    app.get '/', (req, res) ->
      res.sendfile('index.html')
#    routes.addToExpress app, (route, req) ->
#      routes.setActive route, req.params

    app['use'] '/app/styles', express['static'] 'app/styles'
    if isDev
      # Square brackets syntax until we will have Express 4 externs.
      app['use'] '/bower_components', express['static'] 'bower_components'
      app['use'] '/src', express['static'] 'src'

      app['use'] '/build', express['static'] 'build'
      app['use'] '/js', express['static'] 'js'
      app['use'] '/tmp', express['static'] 'tmp'
    else
      # Compiled script has per deploy specific url so set maxAge to one year.
      app['use'] '/src', express['static'] 'src', 'maxAge': 31557600000

    app['listen'] port, ->
      console.log 'Express server listening on port ' + port

  onSaveDocument: (express, req) =>
    res = express.res
    doc = {
      doc: {blocks: [], title: ''}
    }
    settings = {
      font: {textSize: 5}
    }
    documentContents = @documentCreator.renderDocument doc, settings
    console.log res
    res.writeHead 200, 'Content-Type': 'application/html'
    res.write(documentContents)
    res.end()
