goog.provide 'app.StateStorage'

goog.require 'goog.storage.Storage'
goog.require 'goog.storage.mechanism.mechanismfactory'

class app.StateStorage

  ###*
    @constructor
    @final
  ###
  constructor: ->
    @createStorage_()

  ###*
    @type {string}
  ###
  @Key: 'docs-state'

  ###*
    @type {goog.storage.Storage}
    @private
  ###
  storage_: null

  ###*
    @private
  ###
  createStorage_: ->
    mechanism = goog.storage.mechanism.mechanismfactory
      .createHTML5LocalStorage()
    if !mechanism
      throw new Error 'HTML5 Local Storage is not available.'
    @storage_ = new goog.storage.Storage mechanism

  load: ->
    return @storage_.get app.StateStorage.Key

  ###*
    @param {Object} appState
      appState.editingDocumentId - string
  ###
  save: (appState) ->
    @storage_.set app.StateStorage.Key, appState

