goog.require 'app.editor.Block'
goog.require 'app.EditorStore'
goog.require 'tests.Factory'
goog.require 'app.testUtils'

[module, mocks] = tests.Factory.DocumentEditor.createWithMockedParams()
# check correctness
[documentStore, editorStore, blockModule] = mocks

createComponent = (attrs={}) -> module.reactClass(attrs)
createAndRender = (attrs={}) ->
  React.renderComponent createComponent(attrs), app.testUtils.createEl()

suite 'app.editor.Document', ->
  test 'init ok', -> assert.ok module

  suite 'component', ->

    test 'render', ->
      createAndRender()

    test 'render string', ->
      editor = createComponent()
      result = React.renderComponentToStaticMarkup editor
      #:wassert.include result, 'delete document', 'can reset document'

    suite 'recursive render blocks', ->
      setup ->
        @blocks = [
          {
            title: 'V8 (Google Chrome)'
            text: 'V8 engine is used on Google Chrome, Chromium and Opera browsers.'
            type: app.BlockType.Paragraph
          }
          {
            title: 'Chakra (Internet Explorer)'
            text: ''
            type: app.BlockType.List
          }
        ].map tests.Factory.Block.create

      test 'with direct content', ->
        documentView = createAndRender()
        textBlockSpy = sinon.stub documentView, 'textBlockToView'
        [p, list] = documentView.renderBlocks(@blocks)
        assert.equal textBlockSpy.callCount, 2

    suite 'dependencies', ->
      suite 'editorStore deps', ->
        setup ->
          @mock = sinon.mock editorStore

        teardown ->
          @mock.verify()
          @mock.restore()

        test 'delegate onSectionChange', ->
          component = createAndRender()
          @mock.expects('changeSection').once()
          block = {title: 'La putna'}
          changes = {title: 'La LasVegas'}
          component.onSectionChange block, changes
