goog.require 'tests.Factory'
goog.require 'app.testUtils'
goog.require 'app.BlockType'

shortcuts = {}
ImageComponent = new app.editor.Image(shortcuts).reactClass
create = ImageComponent
newEl = app.testUtils.createEl

createAndRender = (opts={}) ->
  opts.block = tests.Factory.Block.create({type: app.BlockType.Image}) unless opts.block?
  React.renderComponent create(opts), newEl()

suite 'app.editor.Block', ->
  setup ->
     @view = createAndRender()

  test 'init ok', ->
    assert.ok @view

  suite 'input handling', ->
    setup -> @view = createAndRender()

    test 'input error initial state', ->
      assert.equal typeof @view.state.inputError, 'undefined'


    suite 'image input', ->
      setup ->
        @view = createAndRender()
        @event = {
          target: {
            files: [
              {type: 'image/png'}
            ]
          }
        }
        @file = @event.target.files[0]

      suite 'not accepted', ->
        setup ->
          @view.props.onImageLoad = sinon.spy()
          @view.setState = sinon.spy()
          @file.type = 'image/bmp'

        test 'set error', ->
          [setStateSpy, onImageLoadSpy] = [@view.setState, @view.props.onImageLoad]
          @view.onFileInput(@event)
          assert.ok setStateSpy.calledOnce
          state = setStateSpy.firstCall.args[0]
          assert.ok state.inputError, 'has error'
          assert.ok onImageLoadSpy.notCalled

      suite 'accepted', ->
        acceptedMimes = [
          'image/png'
          'image/jpeg'
          'image/png'
        ]
        for accepted in acceptedMimes
          do =>
            test "accepts input #{accepted}", ->
              spy = @view.props.onImageLoad = sinon.spy()
              @file.type = accepted
              @view.onFileInput(@event)
              assert.ok spy.called
              assert.equal spy.firstCall.args[0], @view.props.block
              assert.equal spy.firstCall.args[1], @file


