goog.require 'app.testUtils'
goog.require 'app.domAssert'

ReferencePane = app.editor.ReferencePane.reactClass

propsToString = (props={}) ->
  component = ReferencePane(props)
  return React.renderComponentToStaticMarkup(component)

suite 'app.editor.ReferencePane', ->


  setup ->
    component = ReferencePane {
      links: [
        # both marked and reference

        # only reference
      ]
    }
    @pane = React.renderComponentToStaticMarkup(component)

  test 'init ok', ->
    assert.ok @pane

  suite 'reference with marked text', ->
    setup ->
      @pane = propsToString {
        links: [
          {
            marked: 'Javascript is object oriented'
            reference: {title: 'developer.mozilla.org', _id: '10210'}
          }
        ]
      }
    test 'shows reference title', -> assert.include @pane, 'developer.mozilla.org'
    test 'shows marked text', -> assert.include(@pane, 'Javascript is object oriented')
    test 'has action to unlink reference', -> assert.include(@pane, 'unlink')

  suite 'only marked', ->
    setup ->
      @pane = propsToString {
        links: [
          {reference: {}, marked: 'reactive programming'}
        ]
      }
    test 'shows marked text', -> assert.include @pane, 'reactive programming'
    test 'has button to link reference', -> assert.include(@pane, 'add ref')


  suite 'only reference', ->
    setup ->
      @pane = propsToString {
        links: [
          {reference: {title: 'developers.facebook.com', _id: '12030'}}
        ]
      }
    test 'shows reference title', -> assert.include @pane, 'developers.facebook.com'
    test 'has button to mark text', -> assert.include(@pane, 'mark text')


