goog.provide 'app.editor.Section'

goog.require 'app.ui.ActivableBlock'
goog.require 'app.AbstractType'
goog.require 'app.ui.RemoveButton'
goog.require 'app.ui.AppendButton'
goog.require 'app.editor.Block'
goog.require 'app.ui.StructuredMixin'

###*
  Section can have subsections. Can be nested to 3 levels.
###
class app.editor.Section
  ###*
    @param {app.ui.ShortcutsMixin} shortcuts
    @param {app.EditorStore} editorStore
    @constructor
  ###
  constructor: (shortcuts, editorStore) ->
    {input, div, h1, button} = React.DOM
    AppendButton = app.ui.AppendButton.component
    @reactClass = React.createClass(

      mixins: [app.ui.StructuredMixin, shortcuts.mixin, app.ui.ActivableBlock]

      getDefaultProps: ->
        return {
          canNestSection: false
        }

      render: ->
        active = if @props.isActive then 'block-active' else ''
        return div(
          {
            className: "section #{active}"
            key: @props.block._id
            title: @props.block.title
            onClick: @onClick
            onKeyDown: @onShortcut
          }
          @sectionAttrs()
          div({}, @props.renderBlocks(@props.block.blocks))
          div(
            {}
            app.BlockType.getAllForSection().map @addBtn
            @addSectionBtn()
          )
        )

      addSectionBtn: ->
        if @props.canNestSection
          AppendButton({
            type: app.BlockType.Section
            appendHandler: @props.onAppendBlock.bind(null, @props.block, app.BlockType.Section)
          })

      sectionAttrs: ->
        div(
          {className: 'section-attrs'}
          input(
            {
              ref: 'title'
              value: @props.block.title
              onChange: @onTitleChange
              className: 'section-title'
              placeholder: 'new section'
            }
          )
          app.ui.RemoveButton({title: 'remove section', onRemove: @onRemove, classSuffix: 'section'})
        )
    )