goog.provide 'tests.Factory'

goog.require 'app.BlockType'
goog.require 'app.EditorStore'
goog.require 'app.editor.Document'
goog.require 'app.DocumentStore'
goog.require 'app.editor.TransformType'

docStore = new app.DocumentStore()

promise = {then: -> promise}

documentStorage = {
  loadDocument: ->
  saveDocument: ->
}

documentStore = {
  getDocument: ->
  createBlock: ->
  findBlockParent: ->
  getElementBlockTypes: -> ['paragraph', 'list']
  mocked: true
}

editorStore = {
  changeSection: ->
  replaceBlock: ->
  deleteBlock: ->
  getDocument: -> {}
  setAppState: ->
  listen: -> # eventTarget
  mocked: true
}

blockModule = {
  reactClass: ->
}

imageModule = blockModule

sectionModule = blockModule

transform = {
  transformTo: ->
}

routes = {
  view: {url: ->}
  edit: {url: ->}
  format: {url: ->}
}

stateStorage = {
  load: ->
  save: ->
}

class tests.Factory

# rename createDocumentStore
  @DocumentStore: {
    createAndMockStorage: ->
      mock = sinon.mock(documentStorage)
      return [new app.DocumentStore(documentStorage), mock]
  }

  @EditorStore: {
    createWithMockedParams: ->
      store = new app.EditorStore(documentStorage, documentStore, transform, stateStorage)
      store._notify = ->
      store._saveOnly = ->
      return [
        store
        {
          documentStorage: sinon.mock documentStorage
          docStore: sinon.mock documentStore
          transform: sinon.mock transform
        }
      ]
  }

  @BlockReact: {
    createWithMockedParams: (attrs={}) ->
      metaPanel = {
        reactClass: -> {}
      }
      shortcuts = {mixin: {}}
      blockModule = new app.editor.Block(
        editorStore
        routes
        metaPanel
        shortcuts
      )
      attrs['onEditorChange'] = sinon.spy()
      attrs['block'] = tests.Factory.Block.create()
      return blockModule.reactClass(attrs)
  }

  @DocumentEditor: {
    createWithMockedParams: ->
      mockArgs = [
        documentStore
        editorStore
        blockModule
        sectionModule
        imageModule
      ]

      editor = new app.editor.Document(
        mockArgs[0],mockArgs[1],mockArgs[2],mockArgs[3],mockArgs[4]
      )
      return [editor, mockArgs]
  }

  @Document: {
    createWithOpts: (opts={}) ->
      docStore._createDocument(opts)
  }

  @Block: {
    create: (opts={}) ->
      docStore.createBlock(opts)
  }

  @StructureBlock: {
    create: (opts={}) ->
      opts.blocks ?= []
      docStore.createBlock(opts)
  }

  @Section: {
    create: (opts) ->
      opts.type ||= app.BlockType.Section
      docStore.createStructuredBlock(opts)

  }
