goog.provide 'app.references.Editor'

goog.require 'app.ui.Loader'
goog.require 'app.BlockType'
goog.require 'app.references.ShowRefs'

class app.references.Editor

  ###*
    @param {app.references.Store} store
    @constructor
  ###
  constructor: (store) ->

    {ul, li, div} = React.DOM

    ShowTerms = app.references.Terms.reactClass
#    ShowLinks = app.references.Link.reactClass
    ShowCitations = app.references.Citations.reactClass
#    ShowAbbreviations = app.references.Abbreviation.reactClass

    @reactClass = React.createClass(
      displayName: 'citation editor'

      componentDidMount: ->
        store.listen app.references.Store.EventType.Change, @onStoreChange

      onStoreChange: ->
        @forceUpdate() if @isMounted()

      doTitleChange: (ref, event) ->
        store.changeTitle ref, event.target.value

      doAddRef: (refType) ->
        store.addReference(refType)
        if goog.debug
          # binding...
          throw Error 'Ref type expected' unless refType

      loadingFailed: (error) ->
        console.error error
        store.createDocument()
        @forceUpdate()

      ###*
        Called async, must check for mounted.
      ###
      reloadWhenDone: ->
        @forceUpdate() if @isMounted()

      render: ->
        references = store.getReferencesOrPromise()

        view = null
        if Array.isArray(references)
          view = []
          citations = references.filter (ref) -> (ref.type == app.document.Reference.Type.Citation)
          view.push ShowCitations(
            {
              onTitleChange: @doTitleChange
              onRefChange: store.changeReference
              refs: citations
              onAddRef: @doAddRef.bind(@, app.document.Reference.Type.Citation)
            }
          )
          terms = references.filter (ref) -> (ref.type == app.document.Reference.Type.Term)
          view.push ShowTerms({onTitleChange: @doTitleChange, onRefChange: store.changeReference, refs: terms})
          #view.push ...
        else
          references.then(
            @reloadWhenDone
            @loadingFailed
          )
          view = app.ui.Loader({text: 'References are loading.'})
        div(
          {}
          view
        )

#        abbreviations = store.getAbbreviations()


    )
